//Laser Pistol

//Audio

datablock AudioProfile(laserShot1Sound)
{
	filename = "./laserShot1.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(laserBolthitSound)

{
	filename = "./laserBolthit.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(laserBoltLoopSound)
{
   filename    = "./laserBoltLoop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

//effects - taken and modified from Weapon_AlienBlaster by Ladios

//trail
datablock ParticleData(LaserPistolTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 100;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "Add-Ons/Weapon_LaserPistol/LaserPistol/laserparticle.png";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.95 0.95 0.95 1";
	colors[1]	= "0.0 0.85 0.0 0.4";
	colors[2]	= "0.0 0.5 0.0 0.4";
	sizes[0]	= 0.5;
	sizes[1]	= 0.15;
	sizes[1]	= 0.10;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(LaserPistolTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = LaserPistolTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

//muzzle flash effects

datablock ParticleData(LaserPistolFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "Add-Ons/Weapon_LaserPistol/LaserPistol/LaserParticle2.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.95 0.95 0.95 1";
	colors[1]     = "0.0 0.75 0.0 0.6";
	colors[2]     = "0.0 0.75 0.0 0.6";
	colors[3]     = "0.0 0.5 0.0 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 1.5;
	sizes[3]      = 0.4;
	sizes[2]      = 0.8;

	useInvAlpha = false;
};

datablock ParticleEmitterData(LaserPistolFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LaserPistolFlashParticle";

   uiName = "";
};

datablock ParticleData(LaserPistolExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.0 0.85 0.0 0.5";
	colors[1]     = "0.7 0.7 0.7 0.3";
	colors[2]     = "0.6 0.5 0.5 0.0";
	sizes[1]      = 0.5;
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;

	useInvAlpha = true;
};

datablock ParticleEmitterData(LaserPistolExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LaserPistolExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};

datablock ExplosionData(LaserPistolExplosion)
{
	//explosionShape = "";
	soundProfile = laserBolthitSound;

   lifeTimeMS = 150;

   particleEmitter = LaserPistolExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 2;
   lightStartColor = "0.4 0.9 0.4";
   lightEndColor = "0 0 0";
   
	damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 2;
   impulseForce = 200;
};


//Projectile

AddDamageType("LaserPistol",   '<bitmap:add-ons/Weapon_LaserPistol/LaserPistol/CI_LaserPistol> %1',    '%2 <bitmap:add-ons/Weapon_LaserPistol/LaserPistol/CI_LaserPistol> %1',0.2,1);

datablock ProjectileData(LaserBoltProjectile){
	//projectileShapeName = "./LaserBolt.dts"; Removed
   directDamage        = 30;
   directDamageType    = $DamageType::LaserPistol;
   radiusDamageType	   = $DamageType::LaserPistol;
   
   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	   = 0.0;
   verticalImpulse	  = 0.0;
   explosion           = LaserPistolExplosion;
   particleEmitter     = LaserPistolTrailEmitter;
   
   sound = laserboltLoopSound;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 3.0;
   lightColor  = "0.4 0.9 0.4";

   uiName = "Laser Pistol Laser Bolt";
   };
   
   //Item
   
   datablock ItemData(LaserPistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./LaserPistol.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Laser Pistol";
	iconName = "./icon_LaserPistol";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = LaserPistolImage;
	canDrop = true;
};

// Weapon Image

datablock ShapeBaseImageData(LaserPistolImage)
{
   // Basic Item properties
   shapeFile = "./LaserPistol.dts";
   emap = true;
   
      emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = LaserBoltProjectile ;
   projectileType = Projectile;
   
	//melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";
   
    //Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= LaserPistolFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= laserShot1Sound;
	stateEjectShell[2]       		= false;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.25;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			        = "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerDown[4]  = "Fire";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	               = "Ready";

};

function LaserPistolImage::onFire(%this,%obj,%slot)
{

	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	%projectile = %this.projectile;
	%spread = 0.0055;
	Parent::onFire(%this,%obj,%slot);
}
